<?php

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

require_once(JPATH_COMPONENT_SITE . "/lib/dompdf-0.8.2/autoload.inc.php");

use Dompdf\Dompdf;

class osmaControllerAmministrazione extends JControllerLegacy {

    public function visualizzarvmp() {
        if (!JRequest::getVar('idRichiesta')) {
            JApplication::redirect(osmaHelper::router("index.php?option=com_osma&view=amministrazione&layout=elenco-richieste-verifiche-metriche"));
        }

        $db = JFactory::getDbo();

        $db->setQuery("SELECT * FROM #__osma_amministrazione_rvmp WHERE idRichiesta = " . JRequest::getVar('idRichiesta'));

        $richiesta = $db->loadObject();
        $richiesta->intestazione = unserialize($richiesta->intestazione);
        $richiesta->utenteMetrico = unserialize($richiesta->utenteMetrico);
        $richiesta->idPistole = unserialize($richiesta->idPistole);

        $query = $db->getQuery(true);


        if (!$richiesta->manuale) {
            $query->select("*")
                    ->from("#__osma_anagrafica_pistole pi")
                    ->leftJoin("#__osma_anagrafica_matricole mt ON mt.idMatricola = pi.idMatricola")
                    ->leftJoin("#__osma_anagrafica_marche mk ON mt.idMarca = mk.idMarca")
                    ->leftJoin("#__osma_anagrafica_tipologie tp ON mt.idTipologia = tp.idTipologia")
                    ->leftJoin("#__osma_anagrafica_modelli md ON mt.idModello = md.idModello")
                    ->leftJoin("#__osma_anagrafica_prodotti_erogati ero ON ero.idProdottoErogato = pi.idProdottoErogato")
                    ->innerJoin("#__osma_xref_gestore_matricole xref1 ON xref1.idMatricola = mt.idMatricola")
                    ->innerJoin("#__osma_anagrafica_gestori ge ON xref1.idGestore = ge.idGestore")
                    ->where("mt.deleted = 0")
                    ->where("pi.idPistola IN (" . implode(",", $richiesta->idPistole) . ")")
                    ->order("ge.ragioneSociale");

            $db->setQuery($query);
            $pistole = $db->loadObjectList();
        } else {
            $pistole = array();
            for ($i = 0; $i < count($richiesta->idPistole['tipologia']); $i++) {
                $pistole[] = (object) array(
                            'tipologia' => $richiesta->idPistole['tipologia'][$i],
                            'matricolaPistola' => $richiesta->idPistole['matricola'][$i],
                            'marca' => $richiesta->idPistole['marca'][$i],
                            'modello' => $richiesta->idPistole['modello'][$i],
                            'normativa' => $richiesta->idPistole['normativa'][$i],
                            'scadenzaPeriodica' => $richiesta->idPistole['scadenzaPeriodica'][$i],
                            'portata' => $richiesta->idPistole['portata'][$i]
                );
            }
            $pistole = (object) $pistole;
        }

        ob_start();
        require_once (JPATH_COMPONENT_SITE . "/templates/pdf/amministrazione-rvmp.php");
        $result = ob_get_clean();

        $dompdf = new Dompdf();
        $dompdf->loadHtml($result);

        $dompdf->setPaper('A4');
        $dompdf->render();

        $dompdf->stream("rvmp-{$richiesta->idRichiesta}-" . time(), array("Attachment" => false));
        exit;
    }

    public function visualizzapreventivo() {
        if (!JRequest::getVar('idPreventivo')) {
            JApplication::redirect(osmaHelper::router("index.php?option=com_osma&view=amministrazione&layout=elenco-preventivi"));
        }

        $db = JFactory::getDbo();

        $db->setQuery("SELECT p.*, b.intestazione as bIntestazione, b.iban as bIban, b.denominazione as bDenominazione FROM #__osma_amministrazione_preventivi as p INNER JOIN #__osma_anagrafica_banche as b ON b.idBanca = p.idBanca WHERE idPreventivo = " . JRequest::getVar('idPreventivo'));

        $preventivo = $db->loadObject();

        $preventivo->destinazione = unserialize($preventivo->destinazione);
        $preventivo->spettabile = unserialize($preventivo->spettabile);


        $db->setQuery("SELECT * FROM #__osma_amministrazione_preventivi_voci v LEFT OUTER JOIN #__osma_magazzino_codici c ON c.idCodice = v.idCodice WHERE idPreventivo = " . JRequest::getVar('idPreventivo'));

        $preventivo->voci = $db->loadObjectList();

        $pagamenti = array(
            1 => 'Bonifico anticipato',
            2 => 'Bonifico a 60 gg',
            3 => 'Bonifico a 90 gg'
        );

        $preventivo->tipoPagamento = $pagamenti[$preventivo->tipoPagamento];

        ob_start();
        require_once (JPATH_COMPONENT_SITE . "/templates/pdf/amministrazione-preventivo.php");
        $result = ob_get_clean();
        $dompdf = new Dompdf();
        $dompdf->loadHtml($result);

        $dompdf->setPaper('A4');
        $dompdf->render();

        $dompdf->stream("preventivo-{$preventivo->idPreventivo}-" . time(), array("Attachment" => false));
        exit;
    }

    public function generaPreventivo() {

        $post = JRequest::get('post');

        if (!$post['destinazione']['ragioneSociale'] || !$post['destinazione']['indirizzo'] || !$post['destinazione']['comune'] || !$post['destinazione']['cap']) {
            echo new JResponseJson(false, "Compilare tutti i campi dell'utenza di destinazione", true);
            JApplication::close();
        }
        if (!$post['spettabile']['ragioneSociale'] || !$post['spettabile']['indirizzo'] || !$post['spettabile']['comune'] || !$post['spettabile']['cap']) {
            echo new JResponseJson(false, "Compilare tutti i campi dell'utenza di intestazione", true);
            JApplication::close();
        }

        if ($post['rows']) {
            $count = count($post['rows']['codice']);
            $voices = array();
            for ($i = 0; $i < $count; $i++) {
                if ($post['rows']['descrizione'][$i]) {
                    if (!$post['rows']['prezzo'][$i]) {
                        echo new JResponseJson(false, "Compilare il prezzo delle voci del preventivo correttamente", true);
                        JApplication::close();
                    }
                    $voices[] = array(
                        'codice' => $post['rows']['codice'][$i],
                        'descrizione' => $post['rows']['descrizione'][$i],
                        'um' => $post['rows']['um'][$i],
                        'prezzo' => $post['rows']['prezzo'][$i],
                        'quantita' => $post['rows']['quantita'][$i],
                        'sconto' => $post['rows']['sconto'][$i],
                        'totale' => $post['rows']['totale'][$i],
                        'iva' => $post['rows']['iva'][$i],
                    );
                } else {
                    unset($post['rows']['codice'][$i]);
                    unset($post['rows']['descrizione'][$i]);
                    unset($post['rows']['um'][$i]);
                    unset($post['rows']['prezzo'][$i]);
                    unset($post['rows']['quantita'][$i]);
                    unset($post['rows']['sconto'][$i]);
                    unset($post['rows']['totale'][$i]);
                    unset($post['rows']['iva'][$i]);
                }
            }
        } else {
            echo new JResponseJson(false, "Voci del preventivo mancanti", true);
            JApplication::close();
        }

        if (!$post['banca'] || $post['banca'] == 'new') {
            echo new JResponseJson(false, "Seleziona la banca", true);
            JApplication::close();
        }

        $imponibile = 0;
        $totiva = 0;

        foreach ($voices as $i => $vo) {
            if (strpos($vo['codice'], 'new-') !== false) {
                if ($generated[$vo['codice']]) {
                    $voices[$i]['codice'] = $generated[$vo['codice']];
                } else {
                    $old = $vo['codice'];
                    $voices[$i]['codice'] = osmaHelper::genera_nuovo_codice_magazzino(str_replace("new-", "", $vo['codice']));
                    $generated[$old] = $voices[$i]['codice'];
                }
            }

            $val = $vo['prezzo'] * $vo['quantita'];

            if ($vo['sconto']) {
                $val = $val - (($val / 100) * $vo['sconto']);
            }
            $imponibile += $val;

            $totiva += ($val / 100) * $vo['iva'];
        }

        $obj = new stdClass;
        $obj->idGestore = $post['idGestore'];
        $obj->idCliente = $post['idCliente'];
        $obj->utenzaDestinazione = $post['utenzaDestinazione'];
        $obj->utenzaSpettabile = $post['utenzaSpettabile'];
        $obj->destinazione = serialize($post['destinazione']);
        $obj->spettabile = serialize($post['spettabile']);
        $obj->idBanca = $post['banca'];
        $obj->tipoPagamento = $post['tipoPagamento'];
        $obj->totaleImponibile = $imponibile;
        $obj->totaleIva = $totiva;
        $obj->totalePreventivo = $totiva + $imponibile;

        $db = JFactory::getDbo();

        if (JRequest::getVar("idPreventivo")) {
            $obj->idPreventivo = JRequest::getVar("idPreventivo");
            $db->updateObject("#__osma_amministrazione_preventivi", $obj, 'idPreventivo');
            $idPreventivo = $obj->idPreventivo;

            $db->setQuery("DELETE FROM #__osma_amministrazione_preventivi_voci WHERE idPreventivo = " . $idPreventivo);
            $db->execute();
            $db->setQuery("DELETE FROM #__osma_amministrazione_preventivi_pistole WHERE idPreventivo = " . $idPreventivo);
            $db->execute();
        } else {
            $db->insertObject("#__osma_amministrazione_preventivi", $obj, 'idPreventivo');
            $idPreventivo = $db->insertid();
        }

        foreach ($voices as $vo) {
            $obj = new stdClass;
            $obj->idPreventivo = $idPreventivo;
            $obj->idCodice = $vo['codice'];
            $obj->descrizione = $vo['descrizione'];
            $obj->um = $vo['um'];
            $obj->prezzo = $vo['prezzo'];
            $obj->quantita = $vo['quantita'];
            $obj->sconto = $vo['sconto'];
            $obj->totale = $vo['totale'];
            $obj->iva = $vo['iva'];

            $db->insertObject("#__osma_amministrazione_preventivi_voci", $obj, 'idVoce');
        }

        if ($post['idPistole']) {
            foreach ($post['idPistole'] as $pistola) {
                $obj = new stdClass;
                $obj->idPreventivo = $idPreventivo;
                $obj->idPistola = $pistola;
                $db->insertObject("#__osma_amministrazione_preventivi_pistole", $obj, 'idPrevPistola');
            }
        }

        echo new JResponseJson(null, null);
        JApplication::close();
    }

    public function aggiungiBanca() {
        if (!JRequest::getVar("denominazione") || !JRequest::getVar("iban") || !JRequest::getVar("intestazione")) {
            echo new JResponseJson(null, "Errore", true);
            JApplication::close();
        }

        $db = JFactory::getDbo();

        $obj = new stdClass();
        $obj->denominazione = JRequest::getVar("denominazione");
        $obj->iban = JRequest::getVar("iban");
        $obj->intestazione = JRequest::getVar("intestazione");

        $db->insertObject("#__osma_anagrafica_banche", $obj, 'idBanca');

        echo new JResponseJson(array("option" => "<option value='" . $db->insertid() . "' selected>{$obj->denominazione}</option>"));
        JApplication::close();
    }

    public function ignoraScadenza() {
        if (!JRequest::getVar("idPistola")) {
            echo new JResponseJson(null, "Errore", true);
            JApplication::close();
        }

        $db = JFactory::getDbo();

        $obj = new stdClass();
        $obj->idPistola = JRequest::getVar("idPistola");
        $obj->ignoraScadenza = 1;

        $db->updateObject("#__osma_anagrafica_pistole", $obj, 'idPistola');

        echo new JResponseJson(null, null);
        JApplication::close();
    }

    public function check_progressivo_rvmp() {
        $progressivo = JRequest::getVar("progressivo");
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);

        $query->select("COUNT(*)")->from("#__osma_amministrazione_rvmp")->where("YEAR(inserted) = YEAR(NOW())")->where("progressivo = " . $progressivo);
        $db->setQuery($query);

        if ($db->loadResult()) {
            echo new JResponseJson(null, null, true);
        } else {
            echo new JResponseJson(null, null);
        }
        JApplication::close();
    }

    public function set_fatturato() {
        $db = JFactory::getDbo();

        if (JRequest::getVar("idPreventivo")) {
            $obj = new stdClass();
            $obj->idPreventivo = JRequest::getVar("idPreventivo");
            $obj->fatturato = JRequest::getVar("value") == "true" ? "1" : "0";
            $db->updateObject("#__osma_amministrazione_preventivi", $obj, "idPreventivo");
        } else {
            $obj = new stdClass();
            $obj->idRichiesta = JRequest::getVar("idRichiesta");
            $obj->fatturato = JRequest::getVar("value") == "true" ? "1" : "0";
            $db->updateObject("#__osma_amministrazione_rvmp", $obj, "idRichiesta");
        }

        echo new JResponseJson(null, null);
        JApplication::close();
    }

    public function removePreventivo() {
        if (!JRequest::getVar("idPreventivo")) {
            echo new JResponseJson(null, "Errore", true);
            JApplication::close();
        }
        $db = JFactory::getDbo();

        $db->setQuery("DELETE FROM #__osma_amministrazione_preventivi WHERE idPreventivo = " . JRequest::getVar("idPreventivo"));
        $db->execute();
        $db->setQuery("DELETE FROM #__osma_amministrazione_preventivi_voci WHERE idPreventivo = " . JRequest::getVar("idPreventivo"));
        $db->execute();
        $db->setQuery("DELETE FROM #__osma_amministrazione_preventivi_pistole WHERE idPreventivo = " . JRequest::getVar("idPreventivo"));
        $db->execute();

        echo new JResponseJson(null, null);
        JApplication::close();
    }

    public function removeRVMP() {
        if (!JRequest::getVar("idRichiesta")) {
            echo new JResponseJson(null, "Errore", true);
            JApplication::close();
        }
        $db = JFactory::getDbo();
        $db->setQuery("DELETE FROM #__osma_amministrazione_rvmp WHERE idRichiesta = " . JRequest::getVar("idRichiesta"));

        $db->execute();
        echo new JResponseJson(null, null);
        JApplication::close();
    }

    public function inviaMailPreventivo() {
        $post = JRequest::get('post');

        if (!$post['email'] && !$post['otherMail']) {
            echo new JResponseJson(null, "Errore", true);
            JApplication::close();
        }

        if (!$post['preventivo'] && !$post['richiesta']) {
            echo new JResponseJson(null, "Errore", true);
            JApplication::close();
        }

        $config = JFactory::getConfig();
        $mailer = JFactory::getMailer();
        $mailer->setSender(array(
            $config->get('mailfrom'),
            $config->get('fromname')
        ));
        $mailer->setSubject('Invio preventivo ' . ($post['richiesta'] ? "e R.V.M.P. " : "") . 'da OSMA SNC');
        $mailer->setBody("In allegato trovate preventivo " . ($post['richiesta'] ? "e R.V.M.P. " : "") . "da OSMA SNC. Si prega di inviarlo compilato in ogni sua parte all'indirizzo email " . COM_OSMA_MAIL_UFFICIO);

        foreach ($post['email'] as $mail) {
            if (trim($mail)) {
                $mailer->addRecipient(trim($mail));
            }
        }

        foreach (explode(";", $post['otherMail']) as $mail) {
            if (trim($mail)) {
                $mailer->addRecipient(trim($mail));
            }
        }
        if ($post['preventivo']) {
            $ida = "preventivo-{$post['idPreventivo']}";
            file_put_contents(JPATH_COMPONENT . "/tmp/{$ida}.pdf", file_get_contents(JUri::root() . "index.php?option=com_osma&task=amministrazione.visualizzapreventivo&idPreventivo={$post['idPreventivo']}&format=raw"));
            $mailer->addAttachment(JPATH_COMPONENT . "/tmp/{$ida}.pdf");
        }
        if ($post['richiesta']) {
            $idb = "rvmp-{$post['idRichiesta']}";
            file_put_contents(JPATH_COMPONENT . "/tmp/{$idb}.pdf", file_get_contents(JUri::root() . "index.php?option=com_osma&task=amministrazione.visualizzarvmp&idRichiesta={$post['idRichiesta']}&format=raw"));
            $mailer->addAttachment(JPATH_COMPONENT . "/tmp/{$idb}.pdf");
        }

        if ($mailer->Send() !== true) {
            mailerHelper::logMail($mailer, 1, false, $post['idPreventivo']);
            echo new JResponseJson(null, "Errore", true);
        } else {
            mailerHelper::logMail($mailer, 1, true, $post['idPreventivo']);
            echo new JResponseJson(null, null);
        }

        unlink(JPATH_COMPONENT . "/tmp/{$ida}.pdf");
        unlink(JPATH_COMPONENT . "/tmp/{$idb}.pdf");
        JApplication::close();
    }

    public function salvaScadenza() {
        $db = JFactory::getDbo();

        $obj = new stdClass;
        $obj->idGestore = JRequest::getVar("idGestore");
        $obj->data = JRequest::getVar("data");
        $obj->scadenza = JRequest::getVar("scadenza");

        list($d, $m, $y) = explode("/", $obj->data);
        $obj->data = "{$y}-{$m}-{$d}";

        if (JRequest::getVar("idScadenza")) {
            $obj->idScadenza = JRequest::getVar("idScadenza");
            $db->updateObject("#__osma_amministrazione_scadenziario", $obj, "idScadenza");
        } else {
            $db->insertObject("#__osma_amministrazione_scadenziario", $obj, "idScadenza");
        }

        echo new JResponseJson(null, null);
        JApplication::close();
    }

    public function aggiornaScadenza() {

        if (!JRequest::getVar("idScadenza")) {
            echo new JResponseJson(null, true);
            JApplication::close();
        }

        $strtotime = osmaHelper::aggiornaDataScadenziario(JRequest::getVar("idScadenza"));

        echo new JResponseJson(array("data" => date("d/m/Y", $strtotime)));
        JApplication::close();
    }

}
