<?php

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

class OsmaModelClienti extends JModelList {

    public function getItems() {
        $db = JFactory::getDBO();
        $query = $this->costruisciQuery();
        $db->setQuery($query, $this->limitstart, $this->limit);
        $results = $db->loadObjectList();
        return $results;
    }

    public function getTotal() {
        $db = JFactory::getDBO();
        $query = $this->costruisciQuery();
        $db->setQuery($query);
        $db->query();
        $results = $db->getNumRows();
        return $results;
    }

    protected function populateState($ordering = null, $direction = null) {
        $app = JFactory::getApplication('administrator');

        $search = $app->getUserStateFromRequest($this->context . '.filter.search', 'filter_search');
        //Omit double (white-)spaces and set state
        $this->setState('filter.search', preg_replace('/\s+/', ' ', $search));
        parent::populateState('ordering', 'ASC');
    }

    public function __construct($config = array()) {
        $config['filter_fields'] = array(
            'ordering',
            'search'
        );
        parent::__construct($config);
        $mainframe = JFactory::getApplication();
        $this->limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
        $this->limitstart = JRequest::getVar('limitstart', 0, '', 'int');
        $this->limitstart = ($this->limit != 0 ? (floor($this->limitstart / $this->limit) * $this->limit) : 0);

        $this->setState('limit', $this->limit);
        $this->setState('limitstart', $this->limitstart);
    }

    public function getCliente() {

        $db = JFactory::getDBO();
        $query = $db->getQuery(true);

        $query->select("*")->from("#__osma_anagrafica_clienti")->where("idCliente = " . JRequest::getVar("idCliente"));

        $db->setQuery($query);
        return $db->loadObject();
    }

    public function costruisciQuery() {
        //$filterCompanyName = JRequest::getVar('filterCompanyName');

        $db = JFactory::getDBO();
        $query = $db->getQuery(true);

        $search = $db->escape($this->getState('filter.search'));
        $query->select("*")
                ->from("#__osma_anagrafica_clienti as c")
                ->leftJoin("#__osma_clienti_contatti as cc ON c.idCliente = cc.idCliente")
                ->where("deleted = 0")
                ->order("ragioneSociale ASC");

        if (!empty($search)) {
            $query->where("(c.ragioneSociale LIKE " . $db->q('%' . $search . '%') . " OR cc.riferimento LIKE " . $db->q('%' . $search . '%') . ")");
        }

        return $query;
    }

    function addClientiForm() {
        $db = JFactory::getDBO();
        $type = 1;

        $idCliente = JRequest::getVar("id") ? JRequest::getVar("id") : "0";

        if ($idCliente) {
            $query = "SELECT *
            FROM #__osma_anagrafica_clienti
            WHERE idCliente = " . $idCliente;

            $db->setQuery($query);
            $data = $db->loadObject();

            //trovo contatti
            $query = "SELECT *
            FROM #__osma_clienti_contatti
            WHERE idCliente = " . $idCliente . " ORDER BY riferimento ASC";

            $db->setQuery($query);
            $contatti = $db->loadObjectList();
            if ($data->idUser) {
                $user = JFactory::getUser($data->idUser);
                $data->username = $user->get('username');
                $data->usernameemail = $user->get('email');
            }
        }

        include('components/com_osma/templates/addcliente.php');
    }

    function viewContatti() {
        $id = JRequest::getVar("id");
        $type = JRequest::getVar("type");

        $contatti = osmaHelper::viewContattiList($id, $type);

        include('components/com_osma/templates/viewcontatti.php');
    }

    function pubblica() {
        $ids = JRequest::getVar("ids");
        $type = JRequest::getVar("type");

        $return = osmaHelper::pubblica($ids, $type);

        return $return;
    }

    function sospendi() {
        $ids = JRequest::getVar("ids");
        $type = JRequest::getVar("type");

        $return = osmaHelper::sospendi($ids, $type);

        return $return;
    }

    function rimuovi() {
        $ids = JRequest::getVar("ids");
        $type = JRequest::getVar("type");

        $return = osmaHelper::rimuovi($ids, $type);

        return $return;
    }

    function salva() {
        $type = JRequest::getVar("type");
        $return = osmaHelper::salva($type);

        echo $return;
    }

}
