<?php

/**
 * @package     Joomla.Administrator
 * @subpackage  com_helloworld
 *
 * @copyright   Copyright (C) 2005 - 2016 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

/**
 * HelloWorld Model
 *
 * @since  0.0.1
 */
class OsmaModelFornitori extends JModelList {

    public function __construct($config = array()) {
        $config['filter_fields'] = array(
            'ordering',
            'search'
        );
        parent::__construct($config);
        $mainframe = JFactory::getApplication();
        $this->limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
        $this->limitstart = JRequest::getVar('limitstart', 0, '', 'int');
        $this->limitstart = ($this->limit != 0 ? (floor($this->limitstart / $this->limit) * $this->limit) : 0);

        $this->setState('limit', $this->limit);
        $this->setState('limitstart', $this->limitstart);
    }

    public function getItems() {
        $db = JFactory::getDBO();
        $query = $this->costruisciQuery();
        $db->setQuery($query, $this->limitstart, $this->limit);
        $results = $db->loadObjectList();
        return $results;
    }

    public function getTotal() {
        $db = JFactory::getDBO();
        $query = $this->costruisciQuery();
        $db->setQuery($query);
        $db->query();
        $results = $db->getNumRows();
        return $results;
    }

    protected function populateState($ordering = null, $direction = null) {
        $app = JFactory::getApplication('administrator');

        $search = $app->getUserStateFromRequest($this->context . '.filter.search', 'filter_search');
        //Omit double (white-)spaces and set state
        $this->setState('filter.search', preg_replace('/\s+/', ' ', $search));
        parent::populateState('ordering', 'ASC');
    }

    public function costruisciQuery() {
        //$filterCompanyName = JRequest::getVar('filterCompanyName');

        $db = JFactory::getDBO();
        $query = $db->getQuery(true);

        $search = $db->escape($this->getState('filter.search'));

        if (empty($search)) {
            $query = "SELECT * FROM #__osma_anagrafica_fornitori WHERE deleted=0 ORDER BY ragioneSociale ASC";
        } else {
            $search = $db->Quote('%' . $db->escape($search, true) . '%');

            $query = "SELECT * FROM #__osma_anagrafica_fornitori AS c
               LEFT JOIN #__osma_fornitori_contatti AS cc ON c.idFornitore=cc.idFornitore
               WHERE c.deleted=0 AND cc.published=1";
            $query .= " AND (c.ragioneSociale LIKE " . $search . " OR cc.riferimento LIKE " . $search . ")";
            $query .= " ORDER BY ragioneSociale ASC";
        }

        return $query;
    }

    function addFornitoriForm() {
        $db = JFactory::getDBO();
        $type = 2;

        $idFornitore = JRequest::getVar("id");

        $query = "SELECT *
            FROM #__osma_anagrafica_fornitori
            WHERE idFornitore=" . $idFornitore;

        $db->setQuery($query);
        $db->query();
        $data = $db->loadObject();

        //trovo contatti
        $query = "SELECT *
            FROM #__osma_fornitori_contatti
            WHERE idFornitore = " . $idFornitore . " ORDER BY riferimento ASC";

        $db->setQuery($query);
        $db->query();
        $contatti = $db->loadObjectList();


        include('components/com_osma/templates/addcliente.php');
    }

    function viewContatti() {
        $id = JRequest::getVar("id");
        $type = JRequest::getVar("type");

        $contatti = osmaHelper::viewContattiList($id, $type);

        include('components/com_osma/templates/viewcontatti.php');
    }

    function pubblica() {
        $ids = JRequest::getVar("ids");
        $type = JRequest::getVar("type");

        $return = osmaHelper::pubblica($ids, $type);

        return $return;
    }

    function sospendi() {
        $ids = JRequest::getVar("ids");
        $type = JRequest::getVar("type");

        $return = osmaHelper::sospendi($ids, $type);

        return $return;
    }

    function rimuovi() {
        $ids = JRequest::getVar("ids");
        $type = JRequest::getVar("type");

        $return = osmaHelper::rimuovi($ids, $type);

        return $return;
    }

    function salva() {
        $type = JRequest::getVar("type");
        $return = osmaHelper::salva($type);

        echo $return;
    }

}
