<?php
/**
* @package     Joomla.Administrator
* @subpackage  com_helloworld
*
* @copyright   Copyright (C) 2005 - 2016 Open Source Matters, Inc. All rights reserved.
* @license     GNU General Public License version 2 or later; see LICENSE.txt
*/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

/**
* HelloWorld Model
*
* @since  0.0.1
*/
class OsmaModelMarche extends JModelList
{
  public function getItems()
  {
    $db = JFactory::getDBO();
    $query = $this->costruisciQuery();
    $db->setQuery($query, $this->limitstart, $this->limit);
    $results = $db->loadObjectList();
    return $results;
  }

  public function getTotal() {
    $db = JFactory::getDBO();
    $query = $this->costruisciQuery();
    $db->setQuery($query);
    $db->query();
    $results = $db->getNumRows();
    return $results;
  }

  protected function populateState($ordering = null, $direction = null) {
    $app = JFactory::getApplication('administrator');

    $search = $app->getUserStateFromRequest($this->context . '.filter.search', 'filter_search');
    //Omit double (white-)spaces and set state
    $this->setState('filter.search', preg_replace('/\s+/', ' ', $search));
    parent::populateState('ordering', 'ASC');
  }

  public function __construct($config = array()) {
    $config['filter_fields'] = array(
      'ordering',
      'search'
    );
    parent::__construct($config);
    $mainframe = JFactory::getApplication();
    $this->limit 		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
    $this->limitstart 	= JRequest::getVar('limitstart', 0, '', 'int');
    $this->limitstart 	= ($this->limit != 0 ? (floor($this->limitstart / $this->limit) * $this->limit) : 0);

    $this->setState('limit', $this->limit);
    $this->setState('limitstart', $this->limitstart);
  }

  public function costruisciQuery() {
    //$filterCompanyName = JRequest::getVar('filterCompanyName');

    $db = JFactory::getDBO();
    $query = $db->getQuery(true);

    $search = $db->escape($this->getState('filter.search'));

    if (empty($search)) {
      $query ="SELECT * FROM #__osma_anagrafica_marche WHERE deleted=0 ORDER BY marca ASC";
    }else {
      $search = $db->Quote('%'.$db->escape($search, true).'%');

      $query ="SELECT * FROM #__osma_anagrafica_marche
               WHERE deleted=0";
      $query.=" AND marca LIKE " . $search;
      $query .= " ORDER BY marca ASC";
    }

    return $query;
  }

  function pubblica() {
    $ids = JRequest::getVar("ids");
    $type = JRequest::getVar("type");

    $return = osmaHelper::pubblica($ids,$type);

    return $return;
  }

  function sospendi() {
    $ids = JRequest::getVar("ids");
    $type = JRequest::getVar("type");

    $return = osmaHelper::sospendi($ids,$type);

    return $return;
  }

  function rimuovi() {
    $ids = JRequest::getVar("ids");
    $type = JRequest::getVar("type");

    $return = osmaHelper::rimuovi($ids,$type);

    return $return;
  }

  function salva() {

    $type = JRequest::getVar("type");
    $idMarca=JRequest::getVar("id");
    $return = osmaHelper::salvaStrumenti($type);

    $file = JRequest::getVar('subfile', null, 'files', 'array');


    if ($file['tmp_name']) {
        //Import filesystem libraries. Perhaps not necessary, but does not hurt
        jimport('joomla.filesystem.file');
        //Clean up filename to get rid of strange characters like spaces etc
        $pic = $orig = $idMarca.".jpg";
        //Set up the source and destination of the file

        $orig = JPATH_ROOT . DS . 'components' . DS . 'com_osma' . DS . "files" . DS . "marche" . DS . $orig;
        $pic = JPATH_ROOT . DS . 'components' . DS . 'com_osma' . DS . "files" . DS . "marche" . DS . $pic;

        $src = $file['tmp_name'];
        //First check if the file has the right extension, we need jpg only
        if (strtolower(JFile::getExt($file['name'])) == 'jpg') {
            if (JFile::upload($src, $orig)) {//upload immagine originale

                //ridimensionamento immagine in proporzione
                $new_w = 200;
                $new_h = 150;
                $rapp = $new_w / $new_h;
                list($source_w, $source_h) = getimagesize($orig);
                $sourcerapp = $source_w / $source_h;
                $image = imagecreatefromjpeg($orig);


                if ($source_w >= $source_h) {
                    if ($rapp >= $sourcerapp) {
                        $new_h = round(($new_w * $source_h) / $source_w);
                    } else {
                        $new_w = round(($new_h * $source_w) / $source_h);
                    }
                } else {
                    $new_h = round(($new_w * $source_h) / $source_w);
                }

                $ridim = imagecreatetruecolor($new_w, $new_h);
                imagecopyresampled($ridim, $image, 0, 0, 0, 0, $new_w, $new_h, $source_w, $source_h);
                imagejpeg($ridim, $pic);

                //crop immagine nelle dimensioni richieste
              /*  $canvas = imagecreatetruecolor(200,150);
                list($source_w, $source_h) = getimagesize($pic);
                $image = imagecreatefromjpeg($pic);
                imagecopy($canvas, $image, 0, 0, (($source_w / 2) - (100)), (($source_h / 2) - (75)), $source_w, $source_h);
                imagejpeg($canvas, $pic);*/

                $return = "correct";

            } else {
                //Redirect and throw an error message
                $return ="error";
            }
          }else{
              $return ="format";
          }
        }


    echo $return;
  }

  function viewTipologie() {
    $db = JFactory::getDBO();
    $id = JRequest::getVar("id");

    $query="SELECT tipologia
    FROM #__osma_anagrafica_tipologie AS t
    LEFT JOIN #__osma_xref_marca_tipologie AS xmt ON xmt.idTipologia=t.idTipologia
    WHERE t.published=1 AND t.deleted=0  AND xmt.idMarca=".$id." ORDER BY tipologia ASC";

    $db->setQuery($query);
    $db->query();
    $tipologie = $db->loadObjectList();


    include('components/com_osma/templates/tipologielist.php');
  }

  public function getTipologie()
  {
    $db = JFactory::getDBO();
    $query = "SELECT idTipologia,tipologia
              FROM #__osma_anagrafica_tipologie AS t WHERE published=1 AND deleted=0 ORDER BY tipologia ASC";
    $db->setQuery($query);
    $results = $db->loadObjectList();

    return $results;
  }

  function getTipologieSelected(){
    $db = JFactory::getDBO();
    $idMarca = JRequest::getVar("idMarca");

    $query = "SELECT idTipologia FROM #__osma_xref_marca_tipologie WHERE idMarca=".$idMarca;
    $db->setQuery($query);
    $db->query();
    $results = $db->loadColumn();
    echo json_encode($results);
  }

}
