<?php

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

class OsmaModelPreventivatore extends JModelList {

    public function getTotal() {
        return count($this->getItems());
    }

    public function getCapitolato() {
        $dbo = JFactory::getDbo();
        $query = $dbo->getQuery(true);

        $query->select("*")->from("#__osma_preventivatore_capitolato")->where("idCapitoloGenitore = 0")->order("prezziario ASC, codiceCapitolo ASC");

        $dbo->setQuery($query);
        $capitolato = $dbo->loadObjectList();
        $this->componi_albero($capitolato);

        return $capitolato;
    }

    private function componi_albero(&$capitolato) {
        $dbo = JFactory::getDbo();
        $query = $dbo->getQuery(true);
        foreach ($capitolato as $k => $capitolo) {
            $query->clear();
            $query->select("*")->from("#__osma_preventivatore_capitolato")->where("idCapitoloGenitore = {$capitolo->idCapitolo}")->order("prezziario ASC, codiceCapitolo ASC");
            $dbo->setQuery($query);
            $sottocapitoli = $dbo->loadObjectList();
            if ($sottocapitoli) {
                $capitolato[$k]->sottocapitoli = $sottocapitoli;
                $this->componi_albero($capitolato[$k]->sottocapitoli);
            }
        }
    }

    public function getChiamata($idChiamata) {
        if (!$idChiamata) {
            return null;
        }

        $dbo = JFactory::getDbo();
        $query = $dbo->getQuery(true);

        $query->select("c.*, cli.ragioneSociale as cRagioneSociale, ge.ragioneSociale as gRagioneSociale, ge.indirizzo as gIndirizzo, ge.comune as gComune, ge.provincia as gProvincia, ge.nrPuntoVendita as gNrPuntoVendita")
                ->from("#__osma_chiamate as c")
                ->innerJoin("#__osma_anagrafica_clienti as cli ON cli.idCliente = c.idCliente")
                ->innerJoin("#__osma_anagrafica_gestori as ge ON ge.idGestore = c.idGestore")
                ->where("c.idChiamata = {$idChiamata}");

        $chiamata = $dbo->setQuery($query)->loadObject();
        $chiamata->emailGestore = $dbo->setQuery("SELECT email FROM #__osma_gestori_contatti WHERE email IS NOT NULL AND email != '' AND idGestore = " . $chiamata->idGestore . " LIMIT 0,1")->loadResult();
        $chiamata->emailCliente = $dbo->setQuery("SELECT email FROM #__osma_clienti_contatti WHERE email IS NOT NULL AND email != '' AND idCliente = " . $chiamata->idCliente . " LIMIT 0,1")->loadResult();

        return $chiamata;
    }

    public function getPreventivo() {
        $dbo = JFactory::getDbo();
        $query = $dbo->getQuery(true);

        if (JRequest::getVar("idPreventivo")) {
            $query->select("*")->from("#__osma_preventivatore_preventivi")->where("idPreventivo = " . JRequest::getVar("idPreventivo"));
            $dbo->setQuery($query);
            $preventivo = $dbo->loadObject();
        } elseif (JRequest::getVar("idChiamata")) {
            $query->select("*")->from("#__osma_preventivatore_preventivi")->where("idChiamata = " . JRequest::getVar("idChiamata"));
            $dbo->setQuery($query);
            $preventivo = $dbo->loadObject();
        }

        if ($preventivo) {
            $query->clear()->select("v.*, c.idCapitolo, c.codiceCapitolo, c.idCapitoloGenitore")->from("#__osma_preventivatore_preventivi_voci as v")->leftJoin("#__osma_preventivatore_capitolato as c ON c.idCapitolo = v.idCapitolo")->where("idPreventivo = " . $preventivo->idPreventivo);
            $preventivo->voci = $dbo->loadObjectList();
            foreach ($preventivo->voci as $voce) {
                if ($voce->idCapitolo) {
                    $voce->codiceCapitoloRaw = osmaHelper::getCapitolatoCode($voce);
                }
            }
        }

        return $preventivo;
    }

    public function getPreventivi() {
        $dbo = JFactory::getDbo();
        $query = $dbo->getQuery(true);
        $query->select("p.*, c.*, cli.ragioneSociale, cli.comune")
                ->from("#__osma_preventivatore_preventivi as p")
                ->innerJoin("#__osma_chiamate c ON c.idChiamata = p.idChiamata")
                ->innerJoin("#__osma_anagrafica_clienti cli ON c.idCliente =cli.idCliente");
        
        return $dbo->setQuery($query)->loadObjectList();
    }

    public function getNextIdPreventivo() {

        return JFactory::getDbo()->setQuery("SELECT MAX(idPreventivo) + 1 FROM #__osma_preventivatore_preventivi")->loadResult();
    }

    public function getItems() {

        switch (JRequest::getVar("layout") ? JRequest::getVar("layout") : "default") {
            case 'default':
                return $this->getCapitolato();
            case 'preventivo':
                return $this->getPreventivo();
        }
    }

}
