<!DOCTYPE html>
<html>
    <head>
        <style>

            html, body, div, span, applet, object, iframe,
            h1, h2, h3, h4, h5, h6, p, blockquote, pre,
            a, abbr, acronym, address, big, cite, code,
            del, dfn, em, font, img, ins, kbd, q, s, samp,
            small, strike, strong, sub, sup, tt, var,
            dl, dt, dd, ol, ul, li,
            fieldset, form, label, legend,
            table, caption, tbody, tfoot, thead, tr, th, td {
                margin: 0;
                padding: 0;
                border: 0;
                outline: 0;
                font-weight: inherit;
                font-style: inherit;
                font-size: 100%;
                font-family: inherit;
                vertical-align: baseline;
            }
            :focus {
                outline: 0;
            }
            body {
                line-height: 1;
                color: black;
                background: white;
            }
            ol, ul {
                list-style: none;
            }
            table {
                border-collapse: separate;
                border-spacing: 0;
            }
            caption, th, td {
                text-align: left;
                font-weight: normal;
            }
            blockquote:before, blockquote:after,
            q:before, q:after {
                content: "";
            }
            blockquote, q {
                quotes: "" "";
            }

            img {
                -ms-interpolation-mode: bicubic;
            }

            * {
                box-sizing: border-box;
                font-size: 14px;
                line-height: 1.1;
                font-family: 'Helvetica', sans-serif;
            }

            html body {
                font-size: 12px;
                line-height: 1.1;
                font-family: 'Helvetica', sans-serif;
                padding: 1.25cm 1.25cm 2cm;
                position: relative;
            }

            .pull-left {
                float: left;
            }

            .clearfix{
                content: "";
                display: table;
                width: 100%; 
                clear: both;
            }

            table {
                width: 100%;
            }

            hr {
                border: 0;
            }
            label {
                font-weight: bold;
            }

            table td {
                vertical-align: middle;
            }

            p.page-braker { page-break-after: always; }

            .font10, .font10 td {font-size: 10px;}
            .font11, .font11 td {font-size: 11px;}
            .font12, .font12 td {font-size: 12px;}
            .font14, .font14 td {font-size: 14px;}

            .main-table thead tr td {border-left: 1px solid #DFDFDF; text-transform: uppercase; color: #AEAEAE; padding: 5px}
            .main-table tbody tr td {border-left: 1px solid #DFDFDF; border-top: 1px solid #DFDFDF; padding: 5px;}

            footer {position: fixed; left: 1.25cm; right: 1.25cm; bottom: 4.5cm;}
        </style>
    </head>
    <body>
        <table style="border-bottom: 5px solid #21418E; margin: 0;" class="font12">
            <tr>
                <td style="width: 32%; vertical-align: top; padding-bottom: 15px; padding-right: 15px;">
                    <?php if ($chiamata->idLogo == 1) { ?>
                        <img src="<?php echo JPATH_COMPONENT ?>/templates/assets/img/logo_osma.jpg" style="max-height: 85px"/>
                    <?php } elseif ($chiamata->idLogo == 2) { ?>
                        <img src="<?php echo JPATH_COMPONENT ?>/templates/assets/img/logo_e2oil.jpg" style="max-height: 85px;"/>
                    <?php } ?>
                </td>
                <td style="width: 34%; vertical-align: top; padding-bottom: 15px;">
                    <?php if ($chiamata->idLogo == 1) { ?>
                        <b>OSMA S.N.C.<br/>
                            di Pisarra Ottavio & C.</b><br/>
                        Via Zona Industriale 8<br/>
                        28891, Nonio (VB)
                    <?php } elseif ($chiamata->idLogo == 2) { ?>
                        <b>E2oil di Resta Luca</b><br/>
                        Via Maestri del Lavoro 20/22<br/>
                        20813, Bovisio Masciago (MB)
                    <?php } ?>
                </td>
                <td style="width: 34%; vertical-align: top; padding-bottom: 15px;">
                    <?php if ($chiamata->idLogo == 1) { ?>
                        P.I.: 01971090038<br/>
                        C.F.: 01971090038<br/>
                        Tel.: 0323.889158<br/>
                        Fax: 0323.889122<br/>
                        osmasnc@osmasnc.it
                    <?php } elseif ($chiamata->idLogo == 2) { ?>
                        P.I.: 09169480960<br/>
                        C.F.: RSTLCU81E21I441Y<br/>
                        Tel.: 0362.1791410<br/>
                        Fax: 0362.1513079<br/>
                        www.e2oil.it
                    <?php } ?>
                </td>
            </tr>
        </table>

        <hr style="height: 15px; margin: 0"/>

        <table style="margin: 0;" class="font12">
            <thead>
                <tr>
                    <td style="width: 47.5%; padding-bottom: 5px; padding-top: 5px; color: #AEAEAE">
                        SPETTABILE
                    </td>
                    <td style="width: 5%; border-right: 1px solid #DFDFDF;">

                    </td>
                    <td style="width: 47.5%; padding-left: 15px; padding-bottom: 5px; padding-top: 5px; color: #AEAEAE">
                        DESTINAZIONE
                    </td>
                </tr>
            </thead>
            <tbody>
                <tr>
                    <td style=" padding-bottom: 5px; vertical-align: top;">
                        <?php echo $cliente->ragioneSociale ?><br/>
                        <?php echo $cliente->indirizzo ?><br/>
                        <?php echo str_pad($cliente->cap, 5, 0, STR_PAD_LEFT) ?>, <?php echo $cliente->comune ?> (<?php echo $cliente->provincia ?>)<br/>
                        <b>P.IVA</b> <?php echo $cliente->piva ?><br/>
                        <b>C.F.</b> <?php echo $cliente->cf ?><br/>
                    </td>
                    <td style="border-right: 1px solid #DFDFDF;">

                    </td>
                    <td style="padding-left: 15px; padding-bottom: 5px; vertical-align: top;">
                        <?php echo $gestore->ragioneSociale ?><br/>
                        <?php echo $gestore->indirizzo ?><br/>
                        <?php echo str_pad($gestore->cap, 5, 0, STR_PAD_LEFT) ?>, <?php echo $gestore->comune ?> (<?php echo $gestore->provincia ?>)<br/>
                        <b>Cod. impianto</b> <?php echo $gestore->nrPuntoVendita ?><br/>
                    </td>
                </tr>
            </tbody>
        </table>

        <hr style="height: 7px"/>

        <div style="padding: 15px 0; border-top: 3px solid #21418E; border-bottom: 3px solid #21418E; font-weight: bold; text-align: right" class="font14">
            Preventivo N. <?php echo str_pad($preventivo->idPreventivo, 6, "0", STR_PAD_LEFT) ?>/<?php echo date("Y", strtotime($preventivo->inserted)) ?><br/>
            Rif. chiamata: <?php echo $chiamata->nrChiamata ?><br/>
            Data: <?php echo date("d/m/Y", strtotime($preventivo->inserted)) ?>
        </div>

        <hr style="height: 10px"/>

        <div style="text-align: justify;" class="font12">
            <?php echo $chiamata->descrizioneGenerale ?>
        </div>

        <hr style="height: 3px"/>

        <table style="border: 1px solid #DFDFDF" cellspacing="0" cellpadding="3" class="main-table">
            <thead>
                <tr class="font11">
                    <td style="width: 4%">ID</td>
                    <td style="width: 10%">Codice</td>
                    <td >Descrizione</td>
                    <td style="text-align: center; width: 3.5%">U.M.</td>
                    <td style="text-align: right; width: 7%">Q.tà</td>
                    <td style="text-align: right; width: 10%">P.U.</td>
                    <td style="text-align: right; width: 10%">Totale</td>
                    <td style="text-align: right; width: 5%">%</td>
                    <td style="text-align: right; width: 10%">Importo</td>
                </tr>
            </thead>
            <tbody>
                <?php foreach ($preventivo->voci as $vo) { ?>
                    <tr class="font10">
                        <td style=""><?php echo $vo->idCapitolo ? $vo->idCapitolo : "-" ?></td>
                        <td style=""><?php echo $vo->codiceCapitoloRaw ? $vo->codiceCapitoloRaw : "-" ?></td>
                        <td style=""><?php echo $vo->nome ?></td>
                        <td style="text-align: center;"><?php echo strtoupper($vo->um) ?></td>
                        <td style="text-align: right;"><?php echo number_format($vo->quantita, 0, ",", ".") ?></td>
                        <td style="text-align: right;"><?php echo number_format($vo->prezzoUnitario, 2, ",", ".") ?> €</td>
                        <td style="text-align: right;"><?php echo number_format($vo->totale, 2, ",", ".") ?> €</td>
                        <td style="text-align: right;"><?php echo number_format($vo->sconto, 0, ",", ".") ?>%</td>
                        <td style="text-align: right;"><?php echo number_format($vo->importo, 2, ",", ".") ?> €</td>
                    </tr>
                <?php } ?>
                <?php for ($i = 0; $i < (15 - count($preventivo->voci)); $i++) { ?>
                    <tr>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                    </tr>
                <?php } ?>
            </tbody>
        </table>


        <hr style="height: 3px"/>

        <div style="text-align: justify;" class="font12">
            <b>Note:</b> <?php echo $preventivo->note ? $preventivo->note : "-" ?>
        </div>

        <hr style="height: 3px"/>

        <footer style="border-top: 3px solid #21418E; padding-top: 15px;">
            <table style="" cellspacing="0" cellpadding="3" class="main-table">
                <thead>
                    <tr class="font12">
                        <td style="width: 55%; border: 0; text-align: left; border: 0"></td>
                        <td style="width: 25%; border: 0; text-align: right; border: 0; padding-left: 20px;">Totale lavori</td>
                        <td style="width: 5%; border: 0;"></td>
                        <td style="width: 25%; border: 0; text-align: right; border: 0; padding-left: 20px;">Totale preventivo</td>
                    </tr>
                </thead>
                <tbody>
                    <tr class="font14">
                        <td style="border: 0"></td>
                        <td style="border: 0; text-align: right">€ <?php echo number_format($preventivo->totaleLavori, 2, ",", ".") ?></td>
                        <td style="border: 0"></td>
                        <td style="border: 0; text-align: right">€ <?php echo number_format($preventivo->totalePreventivo, 2, ",", ".") ?></td>
                    </tr>
                </tbody>
            </table>

            <hr style="height: 5px"/>

            <table cellpadding="0" class="font12">
                <tbody>
                    <tr>
                        <td style="width: 55%">&nbsp;<br/>&nbsp;<br/>&nbsp;</td>
                        <td style="width: 25%; text-align: center; border-bottom: 1px solid #000; color: #AEAEAE; text-transform: uppercase;">Data<br/><br/></td>
                        <td style="width: 5%"></td>
                        <td style="width: 25%; text-align: center; border-bottom: 1px solid #000; color: #AEAEAE; text-transform: uppercase;">Il cliente<br/><br/></td>
                    </tr>
                </tbody>
            </table>
        </footer>

    </body>
</html>